#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>  /* needs newest pgmspace.h from CVS !*/


/* type definitions */
typedef struct TableEntry
{
  uint8_t     v1;
  int         v2;
  const char  *s;
}TableEntry_t;


/* variables */
static const char  STRING1[]    PROGMEM = { "String 1" };
static const char  STRING2[]    PROGMEM = { "String 2" };


const TableEntry_t Table[] PROGMEM =
  {
    { 1,2, STRING1 },
    { 3,4, STRING2 }
  };



int main(void)
{
    char buf[32];
    
    DDRB  = 0xff;
    
    /* read byte from program memory and output to portB */
    PORTB = ~pgm_read_byte( &Table[1].v1 ); 

    /* read word from program memory and output lower part to portB */
    PORTB = ~ ( pgm_read_word( &Table[1].v2 ) ); 

    
    /* read string from pointer s into ram array */
    strcpy_P( buf, (char *)pgm_read_word(&Table[1].s) );

    PORTB = ~buf[0]; 
    
    for (;;);
}

